// DisplayName = Duel MOD

//--- GAME RULES BEGIN ---
//Please post feedback on www.neonsins.com forums
//Select your inventory loadout as usual (NUM ENTER)
//Request duel by clicking observer in Score Screen (F2)
//Accept/reject duel by pressing VOTE YES/NO
//Re-request duel by pressing VOTE YES
//--- GAME RULES END ---

exec("scripts/DuelMOD/aiDuel.cs");
exec("scripts/DuelMOD/config.cs");
exec("scripts/DuelMOD/spawn.cs");
exec("scripts/DuelMOD/mis_del.cs");

$pi = 3.1415926535897932384626433832795;

package DuelGame {
	function Armor::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType, %momVec)
	{
      %targetObject.lastMomVec = %momVec;

	   if ((!%targetObject.client.DuelInvincible) &&
          ((%targetObject.client.clientDuelingWith == %sourceObject.client) ||
           (%targetObject == %sourceObject) || (%damageType == $DamageType::Suicide) ||
           (%damageType == $DamageType::Ground) || (%targetObject.scriptKilled == 1) ||
           (%damageType == $DamageType::Lava)))
      {
         %targetObject.client.DoNotApplyImpulse = false;
         if (%targetObject != %sourceObject)
            messageClient(%sourceObject.client, 'DuelPartnerDamaged', '~wgui/buttonOver.wav');
         parent::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType, %momVec);
      }
      else
         %targetObject.client.DoNotApplyImpulse = true;
	}

   function Armor::shouldApplyImpulse(%data, %obj)
   {
      return (!%obj.client.InCountdown) && (!%obj.client.DoNotApplyImpulse);
   }

	function Armor::onTrigger(%data, %player, %triggerNum, %val)
	{
		if (!%player.client.InCountdown)
			parent::onTrigger(%data, %player, %triggerNum, %val);
	}

	function Observer::setMode(%data, %obj, %mode, %targetObj)
   {
		parent::setMode(%data, %obj, %mode, %targetObj);
		
		if (%mode $= "observerFly")
			%obj.setTransform("0 0 200 1 0 0 1.4");
	}

	function Observer::onTrigger(%data,%obj,%trigger,%state)
	{
      if (((%obj.mode $= "observerFly") && (%trigger != 0)) || (%obj.mode $= "observerFollow"))
			parent::onTrigger(%data,%obj,%trigger,%state);
	}

   function serverCmdDeclineTask(%client, %issueClient, %description, %teamCmd)
   {
 		if (getSubstr(%description, strlen(%description) - 44, 44) $= "Press ACCEPT COMMAND key to accept challenge")
         Game.DeclineDuelOffer(%issueClient);
		else
			parent::serverCmdDeclineTask(%client, %issueClient, %description, %teamCmd);
   }

	function serverCmdClientJoinGame(%client)
	{
		messageClient(%client, 'LeaveMissionArea', '\c1You can only join the game by requesting or accepting a duel.');
	}

	function serverCmdClientAddToGame(%client, %targetClient)
	{
		messageClient(%client, 'LeaveMissionArea', '\c1You can only join the game by requesting or accepting a duel.');
	}

   function serverCmdClientMakeObserver( %client )
   {
		messageClient(%client, 'LeaveMissionArea', '\c1You cannot leave the duel by becoming an observer.');
   }

   function ELFProjectileData::zapTarget(%data, %projectile, %target, %targeter)
   {
      parent::zapTarget(%data, %projectile, %target, %targeter);

      if ((%target.invincible) ||
          (%target.client.clientDuelingWith != %targeter.client))
      {
         %targeter.elf_zap = true;
         %oldERate = %target.getRechargeRate();
         %target.setRechargeRate(%oldERate + %data.drainEnergy);
      }
      else
      {
         %targeter.elf_zap = false;
      }
   }
   
   function ELFProjectileData::unzapTarget(%data, %projectile, %target, %targeter)
   {
      parent::unzapTarget(%data, %projectile, %target, %targeter);
      
      if (!%target.isDisabled() && %targeter.elf_zap)
      {
         %oldERate = %target.getRechargeRate();
         %target.setRechargeRate(%oldERate - %data.drainEnergy);
      }
   }

   function serverCmdSetPlayerVote(%client, %vote)
   {
      if (%client.clientDuelRequestedBy != 0)
      {
         if (%vote)
            Game.AcceptDuelOffer(%client.clientDuelRequestedBy);
         else
            Game.DeclineDuelOffer(%client.clientDuelRequestedBy);
      }
      else if ((%client.clientDuelingWith == 0) && (%client.JustDueled != 0) && %vote && AllowDuelRequest())
      {
         if (%client.JustDueled.WantsReDuel || %client.JustDueled.isAIControlled())
         {
            if (IsObject(%client.player))
            {
               cancel(%client.killTimer);
               Game.DuelScriptKill(%client);
            }

            if (IsObject(%client.JustDueled.player))
            {
               cancel(%client.JustDueled.killTimer);
               Game.DuelScriptKill(%client.JustDueled);
            }

            if (%client.JustDueled.isAIControlled())
               EquipBotAfterPlayer(%client.JustDueled, %client);

            cancel(%client.reduelTimer);
            cancel(%client.JustDueled.reduelTimer);
            Game.SetupDuel(%client, %client.JustDueled);
            Game.CountDownDuel(%client, %client.JustDueled, 5);
         }
         else if (!IsObject(%client.player))
         {
            bottomPrint(%client.JustDueled, "\nPlayer " @ getTaggedString(%client.name) @ " wants a re-duel.  Press VOTE YES to accept.", 0, 3);
            bottomPrint(%client, "\nDuel re-request sent to player " @ getTaggedString(%client.JustDueled.name) @ ".", 0, 3);
            %client.WantsReDuel = true;
         }
      }
      else
      {
         parent::serverCmdSetPlayerVote(%client, %vote);
      }
   }

   function displayObserverHud(%client, %targetClient, %potentialClient)
   {
      if (!AllowDuelRequest())
         bottomPrint(%client, "\nDuels cannot be requested now.  You have to wait for mission change.", 0, 3);
      else if (%client.clientDuelRequestedBy == 0)
         if (%targetClient > 0)
            bottomPrint(%client, "\nYou are now observing: " @ getTaggedString(%targetClient.name), 0, 3);
         else
            bottomPrint(%client, "<color:ffffff>Welcome to the Duel MOD! (v1.03)\nOriginal T1 and T2 DuelMOD by <color:ffff00>Sly One, system-z and Kahlua<color:ffffff>.\nPress F2 and click on a <color:00dcdc>light blue <color:ffffff>name in the lower half to request a duel.", 0, 3);
   }

//   function chatMessageAll( %sender, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 )
//   {
//      if ( ( %msgString $= "" ) || spamAlert( %sender ) )
//         return;
//
//      %count = ClientGroup.getCount();
//      for ( %i = 0; %i < %count; %i++ )
//      {
//   		%obj = ClientGroup.getObject( %i );
//  	      chatMessageClient( %obj, %sender, %sender.voiceTag, %sender.voicePitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 );
//   	}
//   }
   
   function chatMessageTeam( %sender, %team, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 )
   {
      if ( ( %msgString $= "" ) || spamAlert( %sender ) )
         return;
      %count = ClientGroup.getCount();
      for ( %i = 0; %i < %count; %i++ )
      {
         %obj = ClientGroup.getObject( %i );
         if ((%obj.team == %sender.team) || (%obj.clientDuelingWith == %sender))
            chatMessageClient( %obj, %sender, %sender.voiceTag, %sender.voicePitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 );
      }
   }
   
   // Override the countdown on match start
   function Countdown(%timeMS)
   {
      Game.StartMatch();
   }

   function detonateFlashGrenade(%hg)
   {
      $WhiteoutLastThrownBy = %hg.sourceObject.client;
      parent::detonateFlashGrenade(%hg);
   }

   function Player::setWhiteout(%player, %val)
   {
      if (($WhiteoutLastThrownBy == %player.client) ||
          ($WhiteoutLastThrownBy == %player.client.clientDuelingWith))
          parent::setWhiteout(%player, %val);
   }
   
   function MissileLauncherImage::onFire(%data,%obj,%slot)
   {
      %target = %obj.getLockedTarget();
      if (%target.client == %obj.client.clientDuelingWith)
         Parent::onFire(%data, %obj, %slot);
   }

   function ShapeBaseImageData::onFire(%data, %obj, %slot)
   {
      if (!%obj.client.inCountdown)
         parent::onFire(%data, %obj, %slot);
   }
   
   function AIConnection::startMission(%client)
   {
   	%client.team = 0;
      %client.Initialized = true;
   	Game.AIHasJoined(%client);
   }

   // MA detection
   function ProjectileData::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
   {
      if ((%projectile.dataBlock.getName() $= "DiscProjectile") &&
          (%targetObject.client == %projectile.sourceObject.client.clientDuelingWith))
         if (getPlayerHeight(%targetObject) > $Duel_MAThreshold)
            {
            messageClient(%projectile.sourceObject.client, 'DuelMADetected', '~wfx/misc/flag_lost.wav');
            }

      parent::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal);
   }
};

function DuelGame::setUpTeams(%game)
{
   DefaultGame::setUpTeams(%game);
   %game.numTeams = 1;
   setSensorGroupCount(32);

   $teamDamage = 1;
}

// ----- These functions supercede those in DefaultGame.cs

function DuelGame::allowsProtectedStatics(%game)
{
   return true;
}

function DuelGame::clientMissionDropReady(%game, %client)
{
   messageClient(%client, 'MsgClientReady', "", BountyGame);  // Stealing the Bounty Objective HUD
   messageClient(%client, 'MsgYourScoreIs', "", 0);
   messageClient(%client, 'MsgMissionDropInfo', '\c0You are in mission %1 (%2).', $MissionDisplayName, $MissionTypeDisplayName, $ServerName);
   %game.InitClientVars(%client);
   DefaultGame::clientMissionDropReady(%game,%client);
}

function DuelGame::clientJoinTeam( %game, %client, %team, %respawn )
{
}

function DuelGame::assignClientTeam(%game, %client)
{
   for(%i = 1; %i < 32; %i++)
      $DuelTeamArray[%i] = false;

   %maxSensorGroup = 0;
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++)
   {
      %cl = ClientGroup.getObject(%i);
      if(%cl != %client)
      {
         $DuelTeamArray[%cl.team] = true;
         if (%cl.team > %maxSensorGroup)
            %maxSensorGroup = %cl.team;
      }
   }

   //now loop through the team array, looking for an empty team
   for(%i = 1; %i < 32; %i++)
   {
      if (!$DuelTeamArray[%i])
      {
         %client.team = %i;
         if (%client.team > %maxSensorGroup)
            %maxSensorGroup = %client.team;
         break;
      }
   }

   // set player's skin pref here
   setTargetSkin(%client.target, %client.skin);

   updateCanListenState( %client );

   //now set the max number of sensor groups...
   setSensorGroupCount(%maxSensorGroup + 1);
}

function DuelGame::playerSpawned(%game, %player)
{
   //call the default stuff first...
   DefaultGame::playerSpawned(%game, %player);

	buyFavorites(%player.client);
   %player.selectWeaponSlot(0);
}

function DuelGame::pickPlayerSpawn(%game, %client, %respawn)
{
   if (%client.SpawnPoint != 0)
      return %client.SpawnPoint;
   else
      return "0 0 200";
}

function DuelGame::recalcScore(%game, %client)
{
   if (%client.kills > 0)
//TODO      %client.score = formatDuelScore(%client.kills / (%client.deaths + %client.kills) * 100);
      %client.score = %client.kills / (%client.deaths + %client.kills) * 100;
   else
//TODO      %client.score = formatDuelScore(0);
      %client.score = 0;

   messageClient(%client, 'MsgYourScoreIs', "", formatDuelScore(%client.score));
   %game.recalcTeamRanks(%client);
   %game.checkScoreLimit(%client);
}

// ----- These functions are native to Duel

function DuelGame::timeLimitReached(%game)
{
   logEcho("game over (timelimit)");
   %game.gameOver();
   cycleMissions();
}

function DuelGame::scoreLimitReached(%game)
{
   logEcho("game over (scorelimit)");
   %game.gameOver();
   cycleMissions();
}

function DuelGame::checkScoreLimit(%game, %client)
{
   %scoreLimit = MissionGroup.Duel_scoreLimit;

   if(%scoreLimit $= "")
      %scoreLimit = 1000;
   
	if(%client.score >= %scoreLimit) 
      %game.scoreLimitReached();
}

function DuelGame::gameOver(%game)
{
   //call the default
   DefaultGame::gameOver(%game);

   //send the message
   messageAll('MsgGameOver', "Match has ended.~wvoice/announcer/ann.gameover.wav" );
   messageAll('MsgClearObjHud', "");
   
   for(%i = 0; %i < ClientGroup.getCount(); %i++)
   {
      %client = ClientGroup.getObject(%i);
      %game.resetScore(%client);
      %game.ResetDuelVariables(%client);
   }
}

function DuelGame::resetScore(%game, %client)
{
   %client.score = 0;
   %client.kills = 0;
   %client.deaths = 0;
}

function DuelGame::updateScoreHud(%game, %client, %tag)
{
   // Clear the header:
   messageClient(%client, 'SetScoreHudHeader', "", "");
   messageClient(%client, 'SetScoreHudSubheader', "", '<lmargin:10><just:left>PLAYER<lmargin:185><just:left>ACCURACY<lmargin:330><just:left>PLAYER<lmargin:505><just:left>ACCURACY');

	for (%index = 0; %index < ClientGroup.getCount(); %index++)
		ClientGroup.getObject(%index).WasDisplayed = false;

	%index = 0;
	for (%i = 0; %i < ClientGroup.getCount(); %i++)
   {
      %col1Client = ClientGroup.getObject(%i);
      %col1ClientRank = "";
      %col1Style = "<color:00dcdc>";        

      if ((%col1Client.clientDuelingWith == 0) || (%col1Client.WasDisplayed) || !isObject(%col1Client.player))
			continue;

		if ( %col1Client == %client )
         %col1Style = "<color:dcdcdc>";
		
		%col2Client = %col1Client.clientDuelingWith;
		%col2Client.WasDisplayed = true;
      %col2ClientRank = "";
      %col2Style = "<color:00dcdc>";        

      if ( %col2Client == %client )
         %col2Style = "<color:dcdcdc>";        

      //if the client is not an observer, send the message
      if (%client.team != 0)
      {
			messageClient( %client, 'SetLineHud', "", %tag, %index, '%5<lmargin:10><just:left><clip:180>%1</clip><lmargin:200><just:left>%2<rmargin:305><just:right><color:ff0000>versus<rmargin:570>%6<lmargin:330><just:left><clip:180>%3</clip><lmargin:515><just:left>%4',
  							   %col1Client.name, formatDuelScore(%col1Client.score), %col2Client.name, formatDuelScore(%col2Client.score),
							   %col1Style, %col2Style );
      }
      //else for observers, create an anchor around the player name so they can be observed
      else
      {
			messageClient( %client, 'SetLineHud', "", %tag, %index, '%5<lmargin:10><just:left><clip:180><a:gamelink\t1%7>%1</a></clip><lmargin:200><just:left>%2<rmargin:305><just:right><color:ff0000>versus<rmargin:570>%6<lmargin:330><just:left><a:gamelink\t1%8><clip:180>%3</clip></a><lmargin:515><just:left>%4',
  							   %col1Client.name, formatDuelScore(%col1Client.score), %col2Client.name, formatDuelScore(%col2Client.score),
								%col1Style, %col2Style, %col1Client, %col2Client );
      }
		%index++;
   }

	if (%index == 0)
	{
		messageClient(%client, 'SetLineHud', "", %tag, %index, "");
		%index++;
	}
	
   for (%i = 0; %i < ClientGroup.getCount(); %i++)
      ClientGroup.getObject(%i).sorted = false;

   %clientSortCount = 0;
   while (true)
   {
      %maxScore = -1;
      for (%i = 0; %i < ClientGroup.getCount(); %i++)
      {
         %cl = ClientGroup.getObject(%i);
         if (!%cl.sorted)
         {
            if (%cl.score > %maxScore)
            {
               %clientSort[%clientSortCount] = %cl;
               %maxScore = %cl.score;
            }
         }
      }

      if (%maxScore == -1)
         break;
      else
      {
         %clientSort[%clientSortCount].sorted = true;
         %clientSortCount++;
      }
   }

   messageClient(%client, 'SetLineHud', "", %tag, %index, "<just:center>-----------------------------------------------------------------------------------------------------------------");
   %index++;
	messageClient(%client, 'SetLineHud', "", %tag, %index, '<tab:10, 310><font:Univers Condensed:22>\tClick on a name to duel<rmargin:315><just:right>KILLS<rmargin:390>DEATHS<rmargin:440><just:right>ACC<rmargin:510><just:right>RANK<rmargin:570><just:right>TIME');
   %index++;

   for (%i = 0; %i < %clientSortCount; %i++)
   {
      %cl = %clientSort[%i];

      %clientTimeStr = "";
      if (%cl.observerStartTime != 0)
      {
         %clientTime = getSimTime() - %cl.observerStartTime;
         %clientTimeStr = %game.formatTime(%clientTime, false);
      }
      echo(%cl.score);
      
      if ((%cl != %client) && (%cl.team == 0) && (%client.team == 0) && %cl.Initialized)
         messageClient( %client, 'SetLineHud', "", %tag, %index, '<tab:20, 310>\t<clip:150><a:gamelink\t1%3>%1</a></clip><just:right><rmargin:310><color:ffff00>%6<rmargin:370>%7<rmargin:450><color:ffffff>%5<color:00dcdc><rmargin:510>%4<rmargin:570>%2',
                        %cl.name, %clientTimeStr, %cl, "none", formatDuelScore(%cl.score), %cl.kills, %cl.deaths);
      else
         messageClient( %client, 'SetLineHud', "", %tag, %index, '<tab:20, 310>\t<clip:150><color:0000dc>%1</a></clip><color:00dcdc><just:right><rmargin:310><color:ffff00>%6<rmargin:370>%7<rmargin:450><color:ffffff>%5<color:00dcdc><rmargin:510>%4<rmargin:570>%2',
                        %cl.name, %clientTimeStr, %cl, "none", formatDuelScore(%cl.score), %cl.kills, %cl.deaths);

      %index++;
   }

   messageClient(%client, 'SetLineHud', "", %tag, %index, "");
   %index++;

   if (%client.clientRequestedDuelWith != 0)
   {
   	messageClient( %client, 'SetLineHud', "", %tag, %index, 'Your duel request with %1 is pending (<a:gamelink\t2>CANCEL</a>).',
							%client.clientRequestedDuelWith.name);
      %index++;
   }
   
   if (%client.clientDuelRequestedBy != 0)
   {
   	messageClient( %client, 'SetLineHud', "", %tag, %index, 'Player %1 has requested a duel (<a:gamelink\t3>ACCEPT</a>, <a:gamelink\t4>DECLINE</a>).',
							%client.clientDuelRequestedBy.name);
      %index++;
   }

   //clear the rest of Hud so we don't get old lines hanging around...
   messageClient( %client, 'ClearHud', "", %tag, %index );
}

function DuelGame::updateKillScores(%game, %clVictim, %clKiller, %damageType, %implement)
{
   if (!%clVictim.HasWonDuel && !%clVictim.DrawDuel)
   {
      %clVictim.clientDuelingWith.HasWonDuel = true;
      %clVictim.clientDuelingWith.kills++;
      %clVictim.deaths++;
      %game.recalcScore(%clVictim);
      %game.recalcScore(%clVictim.clientDuelingWith);
      if (%clientDefender.IsIlluminated)
         DisIlluminateClients(%clientDefender, %clientChallenger);
   }
}

function DuelGame::missionLoadDone(%game)
{
	DefaultGame::missionLoadDone(%game);
	deleteNonDuelObjectsFromMap();
 	$InvincibleTime = 5 + $Duel_StartInvincibleTime / 1000;
}

function DuelGame::onClientKilled(%game, %clVictim, %clKiller, %damageType, %implement, %damageLocation)
{     
	%clVictim.player.setMomentumVector(%clVictim.lastMomVec);
	%clVictim.player.blowup();
	DefaultGame::onClientKilled(%game, %clVictim, %clKiller, %damageType, %implement, %damageLocation);

   if(%clVictim.respawnTimer)
      cancel(%clVictim.respawnTimer);

	%clVictim.clientDuelingWith.clientDuelingWith = 0;
// ??
	%clVictim.clientRequestedDuelWith = 0;
	%clVictim.clientDuelRequestedBy = 0;
// ??

   if (!%clVictim.DrawDuel)
   {
   	if (!%clVictim.HasWonDuel)
   		{
   		messageAll('MsgClientJoinTeam', '\c2%1 has won the duel over %2.', %clVictim.clientDuelingWith.name, %clVictim.name);
   		%clVictim.clientDuelingWith.player.setInvincible(1);
   		%clVictim.clientDuelingWith.killTimer = Game.schedule($Duel_VictorKillTime, "DuelScriptKill", %clVictim.clientDuelingWith);
   		%clVictim.clientDuelingWith = 0;
   		messageClient(%clVictim, 'msgBountyTargetIs', "", "<none>");
   		messageClient(%clKiller, 'msgBountyTargetIs', "", "<none>");
         if (AllowDuelRequest())
            bottomPrint(%clVictim, "\nPress VOTE YES key to request re-duel with " @ getTaggedString(%clVictim.JustDueled.name) @ ".", $Duel_VictorKillTime + $Duel_VictorForceObserverTime, 3);
         %clVictim.reduelTimer = %game.schedule($Duel_VictorKillTime + $Duel_VictorForceObserverTime,
                                                "forceObserver", %clVictim, "playerChoose");
         }
      else
      {
         if (!%clVictim.JustDueled.WantsReDuel)
            bottomPrint(%clVictim, "\nPress VOTE YES key to request re-duel with " @ getTaggedString(%clVictim.JustDueled.name) @ ".", $Duel_VictorForceObserverTime, 3);

   		%clVictim.reduelTimer = %game.schedule($Duel_VictorForceObserverTime, "forceObserver",
                                                %clVictim, "playerChoose");
      }
   }
}

function DuelGame::forceObserver( %game, %client, %reason )
{
   //make sure we have a valid client...
   if (%client <= 0)
      return;

   // remove them from the team rank array
   %game.removeFromTeamRankArray(%client);

   // place them in observer mode
   %client.lastObserverSpawn = -1;
   %client.observerStartTime = getSimTime();
   %adminForce = 0;
   
   %client.camera.getDataBlock().setMode(%client.camera, "observerFly");
   %client.lastTeam = %client.team;
      
   // switch client to team 0 (observer)
   %client.team = 0;
   %client.player.team = 0;
// ??
   setTargetSensorGroup(%client.target, %client.team);
   %client.setSensorGroup(%client.team);
// ??

   // set their control to the obs. cam
   %client.setControlObject(%client.camera);
   commandToClient(%client, 'setHudMode', 'Observer');

   updateObserverFlyHud(%client);
   updateCanListenState(%client);
   
   %client.JustDueled = 0;
}

function DuelGame::createPlayer(%game, %client, %spawnLoc, %respawn)
{
	DefaultGame::createPlayer(%game, %client, %spawnLoc, %respawn);
	%client.player.setRespawnCloakOff();
}

function DuelGame::processGameLink(%game, %client, %arg1, %arg2, %arg3, %arg4, %arg5)
{
   switch (getSubStr(%arg1, 0, 1))
   {
      case 1:
         %targetClient = getSubStr(%arg1, 1, strlen(%arg1) - 1);

      	if ((%targetClient.team != 0) || (%client.team != 0))
            {
           	serverCmdHideHud(%client, 'scoreScreen');
         	commandToClient(%client, 'setHudMode', 'Standard', "", 0);
      		DefaultGame::processGameLink(%game, %client, %targetClient, %arg2, %arg3, %arg4, %arg5);
            }
      	else
      		%game.RequestDuel(%client, %TargetClient);
       case 2:
         %game.CancelDuelOffer(%client);
     		serverCmdHideHud(%client, 'scoreScreen');
   		commandToClient(%client, 'setHudMode', 'Standard', "", 0);
       case 3:
         %game.AcceptDuelOffer(%client.clientDuelRequestedBy);
     		serverCmdHideHud(%client, 'scoreScreen');
   		commandToClient(%client, 'setHudMode', 'Standard', "", 0);
       case 4:
         %game.DeclineDuelOffer(%client.clientDuelRequestedBy);
     		serverCmdHideHud(%client, 'scoreScreen');
   		commandToClient(%client, 'setHudMode', 'Standard', "", 0);
       default:
   }
}

function DuelGame::DuelScriptKill(%game, %client)
{
	%client.player.scriptKill(0);
}

// Duel request processing functions
function DuelGame::RequestDuel(%game, %clientRequesting, %clientRequested)
{
	serverCmdHideHud(%clientRequesting, 'scoreScreen');
	commandToClient(%clientRequesting, 'setHudMode', 'Standard', "", 0);
 
   if (!AllowDuelRequest(%clientRequesting, %clientRequested))
      return;

   // check for cross-request
   if (%clientRequested.clientRequestedDuelWith == %clientRequesting)
      {
      %game.AcceptDuelOffer(%clientRequested);
      return;
      }

	if (%clientRequesting.clientRequestedDuelWith != 0)
		messageClient(%clientRequesting, 'LeaveMissionArea', '\c2Your duel request to player %1 is still pending...', %clientRequesting.clientRequestedDuelWith.name);
	else if (%clientRequested.clientDuelRequestedBy != 0)
		messageClient(%clientRequesting, 'LeaveMissionArea', '\c2Player %1 is currently considering someone elses duel request.', %clientRequested.name);
	else
	{
		%clientRequesting.clientRequestedDuelWith = %clientRequested;
		%clientRequested.clientDuelRequestedBy = %clientRequesting;
		%clientRequesting.DuelOfferExpireThread = %game.schedule($Duel_OfferExpirationTime, "DuelOfferExpired", %clientRequesting);

		messageClient(%clientRequested, 'LeaveMissionArea', '\c2Player %1 wants to duel with you.  Press VOTE YES/NO to respond.~wfx/misc/warning_beep.wav', %clientRequesting.name);
      ClearBottomPrint(%clientRequested);
      bottomPrint(%clientRequested, "<color:00dcdc>Player <color:ffffff>" @ getTaggedString(%clientRequesting.name) @ " <color:00dcdc>wants to duel with you.\n\nPress VOTE YES to accept, VOTE NO to decline.", 0, 3);

		serverCmdHideHud(%clientRequested, 'scoreScreen');
		commandToClient(%clientRequested, 'setHudMode', 'Standard', "", 0);

		messageClient(%clientRequesting, 'LeaveMissionArea', '\c2Your duel request has been sent to player %1.', %clientRequested.name);
	}
 
   if (%clientRequested.isAIControlled())
   {
      EquipBotAfterPlayer(%clientRequested, %clientRequesting);
      %game.AcceptDuelOffer(%clientRequesting);
      return;
   }
}

function DuelGame::AcceptDuelOffer(%game, %clientRequesting)
{
   if (%clientRequesting.clientRequestedDuelWith != 0)
   {
      messageClient(%clientRequesting, 'LeaveMissionArea', '\c2Player %1 has accepted your duel challenge.~wfx/misc/warning_beep.wav', %clientRequesting.clientRequestedDuelWith.name);

      if (%clientRequesting.DuelOfferExpireThread != 0)
         {
         cancel(%clientRequesting.DuelOfferExpireThread);
         %clientRequesting.DuelOfferExpireThread = 0;
         }

      // cancel partner's any outstanding duel offer
      %game.CancelDuelOffer(%clientRequesting.clientRequestedDuelWith);
      // decline any outstanding request to this player
      %game.DeclineDuelOffer(%clientRequesting.clientDuelRequestedBy);
      
      %game.SetUpDuel(%clientRequesting, %clientRequesting.clientRequestedDuelWith);
      %game.CountDownDuel(%clientRequesting, %clientRequesting.clientDuelingWith, 5);
   }
}

function DuelGame::DeclineDuelOffer(%game, %clientRequesting)
{
   if (%clientRequesting.clientRequestedDuelWith != 0)
   {
      messageClient(%clientRequesting, 'LeaveMissionArea', '\c2Player %1 has rejected your duel challenge.', %clientRequesting.clientRequestedDuelWith.name);
      messageClient(%clientRequesting.clientRequestedDuelWith, 'LeaveMissionArea', '\c2You have rejected the duel challenge from player %1.', %clientRequesting.name);
      ClearBottomPrint(%clientRequesting.clientRequestedDuelWith);
      %clientRequesting.clientRequestedDuelWith.clientDuelRequestedBy = 0;
      %clientRequesting.clientRequestedDuelWith = 0;

      if (%clientRequesting.DuelOfferExpireThread != 0)
         {
         cancel(%clientRequesting.DuelOfferExpireThread);
         %clientRequesting.DuelOfferExpireThread = 0;
         }
   }
}

function DuelGame::CancelDuelOffer(%game, %clientRequesting)
{
   if (%clientRequesting.clientRequestedDuelWith != 0)
   {
      messageClient(%clientRequesting.clientRequestedDuelWith, 'LeaveMissionArea', '\c2Player %1 cancelled his or her duel offer.', %clientRequesting.name);
      ClearBottomPrint(%clientRequesting.clientRequestedDuelWith);
      %clientRequesting.clientRequestedDuelWith.clientDuelRequestedBy = 0;
      %clientRequesting.clientRequestedDuelWith = 0;

      if (%clientRequesting.DuelOfferExpireThread != 0)
         {
         cancel(%clientRequesting.DuelOfferExpireThread);
         %clientRequesting.DuelOfferExpireThread = 0;
         }
   }
}

function DuelGame::DuelOfferExpired(%game, %clientRequesting)
{
   messageClient(%clientRequesting, 'LeaveMissionArea', '\c2Player %1 has not accepted your duel challenge.', %clientRequesting.clientRequestedDuelWith.name);
   %game.CancelDuelOffer(%clientRequesting);
}

// Duel processing functions
function DuelGame::SetUpDuel(%game, %clientChallenger, %clientDefender)
{
	%clientDefender.clientDuelingWith = %clientChallenger;
	%clientChallenger.clientDuelingWith = %clientDefender;
	%clientChallenger.clientRequestedDuelWith = 0;
	%clientDefender.clientDuelRequestedBy = 0;
	%clientDefender.HasWonDuel = false;
	%clientChallenger.HasWonDuel = false;
	%clientDefender.DrawDuel = false;
	%clientChallenger.DrawDuel = false;
	%clientChallenger.JustDueled = %clientDefender;
	%clientDefender.JustDueled = %clientChallenger;
	%clientDefender.WantsReDuel = false;
	%clientChallenger.WantsReDuel = false;
   %clientDefender.DuelInvincible = true;
   %clientChallenger.DuelInvincible = true;

	PickDuelSpawnPoints(%clientDefender, %clientChallenger);
 	messageAll('MsgClientJoinTeam', '\c2Players %1 and %2 are now dueling.', %clientDefender.name, %clientChallenger.name);

   Game.assignClientTeam(%clientDefender);
	Game.spawnPlayer(%clientDefender, true);
	%clientDefender.camera.setFlyMode();
   if (!%clientDefender.isAIControlled())
   	%clientDefender.setControlObject(%clientDefender.player);
	%clientDefender.player.disableMove(1);
	%clientDefender.InCountdown = true;
   ClearBottomPrint(%clientDefender);
	messageClient(%clientDefender, 'msgBountyTargetIs', "", %clientChallenger.name);

	if (%clientChallenger != %clientDefender)
	{
		Game.assignClientTeam(%clientChallenger);
		Game.spawnPlayer(%clientChallenger, true);
   	%clientChallenger.camera.setFlyMode();
      %clientChallenger.setControlObject(%clientChallenger.player);
		%clientChallenger.player.disableMove(1);
		%clientChallenger.InCountdown = true;
		ClearBottomPrint(%clientChallenger);
		messageClient(%clientChallenger, 'msgBountyTargetIs', "", %clientDefender.name);
	}

   setTargetSensorData(%clientDefender.target, DuelPlayerSensor);
   setTargetSensorData(%clientChallenger.target, DuelPlayerSensor);
   setSensorGroupAlwaysVisMask(%clientDefender.getSensorGroup(), 0);
   setSensorGroupAlwaysVisMask(%clientChallenger.getSensorGroup(), 0);

   %visMask = getSensorGroupAlwaysVisMask(%clientDefender.getSensorGroup());
   %visMask |= (1 << %clientChallenger.getSensorGroup());
   setSensorGroupAlwaysVisMask(%clientDefender.getSensorGroup(), %visMask);

   %visMask = getSensorGroupAlwaysVisMask(%clientChallenger.getSensorGroup());
   %visMask |= (1 << %clientDefender.getSensorGroup());
   setSensorGroupAlwaysVisMask(%clientChallenger.getSensorGroup(), %visMask);

	MakeClientsFaceEachOther(%clientDefender, %clientChallenger);
}

function DuelGame::CountDownDuel(%game, %clientChallenger, %clientDefender, %seconds)
{
   if (%seconds > 2)
      {
		messageClient(%clientChallenger, 'MsgMissionStart', '~wfx/misc/hunters_%1.wav', %seconds);
		messageClient(%clientDefender, 'MsgMissionStart', '~wfx/misc/hunters_%1.wav', %seconds);
		%game.schedule(1000, "CountDownDuel", %clientChallenger, %clientDefender, %seconds - 1);
		}
   else if (%seconds == 2)
		{
      messageClient(%clientChallenger, 'MsgMissionStart', '~wvoice/announcer/ann.match_begins.wav');
      messageClient(%clientDefender, 'MsgMissionStart', '~wvoice/announcer/ann.match_begins.wav');
		%game.schedule(2000, "CountDownDuel", %clientChallenger, %clientDefender, %seconds - 2);
		}
   else
		%game.StartDuel(%clientChallenger, %clientDefender);
}

function DuelGame::StartDuel(%game, %clientChallenger, %clientDefender)
{
	%clientChallenger.player.disableMove(0);
	%clientChallenger.InCountdown = false;

   if (%clientDefender.isAIControlled())
   	{
      %clientDefender.setControlObject(%clientDefender.player);
      %clientDefender.setEngageTarget(%client.clientDuelingWith);
      %clientDefender.setTargetObject(%client.clientDuelingWith);
      }

	%clientDefender.player.disableMove(0);
	%clientDefender.InCountdown = false;
   %game.schedule($Duel_StartInvincibleTime, "RemoveDuelInvincibility", %clientDefender);
   %game.schedule($Duel_StartInvincibleTime, "RemoveDuelInvincibility", %clientChallenger);
}

// temp
function DuelGame::ResetDuelVariables(%game, %client)
{
   %game.InitClientVars(%client);
   if(%client.player)
      %client.player.scriptKill(0);

   %game.forceObserver(%client, "playerChoose");
}

function DuelGame::DumpClientStates(%game)
{
	for (%i = 0; %i < ClientGroup.getCount(); %i++)
	{
		echo("Name: " @ getTaggedString(ClientGroup.getObject(%i).name));
		echo("  clientRequestedDuelWith: " @ getTaggedString(ClientGroup.getObject(%i).clientRequestedDuelWith.name));
		echo("  clientDuelRequestedBy: " @ getTaggedString(ClientGroup.getObject(%i).clientDuelRequestedBy.name));
		echo("  clientDuelingWith: " @ getTaggedString(ClientGroup.getObject(%i).clientDuelingWith.name));
		echo("  team: " @ ClientGroup.getObject(%i).team);
		echo("  InCountdown: " @ ClientGroup.getObject(%i).InCountdown);
		echo("  HasWonDuel: " @ ClientGroup.getObject(%i).HasWonDuel);
//		echo("  : " @ ClientGroup.getObject(%i).);
		echo(" ");
	}
}

function ReloadDuelModCode()
{
	deactivatePackage(DuelGame);
   exec("scripts/DuelMOD/config.cs");
   exec("scripts/DuelMOD/spawn.cs");
   exec("scripts/DuelMOD/mis_del.cs");
	exec("scripts/DuelGame.cs");
	activatePackage(DuelGame);
   InitalizeSpawn();
}

function IlluminateClients(%client1, %client2)
{
   %client2.setTargetId(%client1.target);
   %client2.sendTargetTo(%client2, true);

   %client1.setTargetId(%client2.target);
   %client1.sendTargetTo(%client1, true);
}

function DisIlluminateClients(%client1, %client2)
{
   removeClientTargetType(%client1, "AssignedTask");
   removeClientTargetType(%client2, "AssignedTask");
}

function GetPlayerDistance(%client1, %client2)
{
   return VectorDist(%client1.player.getTransform(), %client2.player.getTransform());
}

function DuelGame::CheckPlayerIllumination(%game)
{
   for (%i = 0; %i < ClientGroup.getCount(); %i++)
   {
      %cl1 = ClientGroup.getObject(%i);
      if (%cl1.clientDuelingWith != 0)
      {
         %cl2 = %cl1.clientDuelingWith;
         if (%cl1.IsIlluminated && (GetPlayerDistance(%cl1, %cl2) < $Duel_IlluminationDistance))
            {
            DisIlluminateClients(%cl1, %cl2);
            %cl1.IsIlluminated = false;
            %cl2.IsIlluminated = false;
            }
         else if (!%cl1.IsIlluminated && (GetPlayerDistance(%cl1, %cl2) > $Duel_IlluminationDistance))
            {
            IlluminateClients(%cl1, %cl2);
            %cl1.IsIlluminated = true;
            %cl2.IsIlluminated = true;
            }
      }
   }

   cancel(Game.IlluminationSchedule);
   Game.IlluminationSchedule = Game.schedule($Duel_IlluminationInterval, "CheckPlayerIllumination");
}

function DuelGame::initGameVars(%game)
{
   DefaultGame::initGameVars(%game);
   Game.IlluminationSchedule = Game.schedule($Duel_IlluminationInterval, "CheckPlayerIllumination");
   Game.DistanceDrawSchedule = Game.schedule($Duel_DistanceDrawInterval, "CheckDistanceDraw");
   Game.AmmoDrawSchedule = Game.schedule($Duel_AmmoDrawInterval, "CheckAmmoDraw");
   InitalizeSpawn();
}

function DuelGame::leaveMissionArea(%game, %playerData, %player)
{
}

function DuelGame::enterMissionArea(%game, %playerData, %player)
{
}

datablock SensorData(DuelPlayerSensor)
{
   detects = false;
   detectsUsingLOS = false;
   detectsPassiveJammed = false;
   detectRadius = 0;
   detectionPings = false;
   detectsFOVOnly = true;
   detectFOVPercent = 1.3;
   useObjectFOV = true;
};

function DuelGame::InitClientVars(%game, %client)
{
	%client.clientRequestedDuelWith = 0;
	%client.clientDuelRequestedBy = 0;
	%client.clientDuelingWith = 0;
 	%client.InCountdown = false;
   %client.team = 0;
   %client.Initialized = true;
   %game.resetScore(%client);
}

function formatDuelScore(%score)
{
   if (getsubstr(%score, strlen(%score) - 1, 1) $= "%")
      return %score;
   else
      return getSubstr((mFloor(%score * 10) / 10) + 0.0001, 0, 4) @ "%";
}

function DuelGame::DrawDuel(%game, %client1, %reason)
{
	if (%client1.clientDuelingWith == 0)
      return 0;
      
   %client2 = %client1.clientDuelingWith;
	messageAll('DuelResultDraw', '\c2Duel between %1 and %2 ends in a draw.', %client1.name, %client2.name);

   %client1.DrawDuel = true;
	%client1.clientDuelingWith = 0;
   %game.DuelScriptKill(%client1);
   %client1.reduelTimer = %game.schedule($Duel_VictorKillTime + $Duel_VictorForceObserverTime, "forceObserver", %client1, "playerChoose");
   bottomPrint(%client1, "\n<color:ffffff>" @ %reason, $Duel_VictorKillTime + $Duel_VictorForceObserverTime, 3);
	messageClient(%client1, 'msgBountyTargetIs', "", "<none>");

   %client2.DrawDuel = true;
	%client2.clientDuelingWith = 0;
   %game.DuelScriptKill(%client2);
   %client2.reduelTimer = %game.schedule($Duel_VictorKillTime + $Duel_VictorForceObserverTime, "forceObserver", %client2, "playerChoose");
   bottomPrint(%client2, "\n<color:ffffff>" @ %reason, $Duel_VictorKillTime + $Duel_VictorForceObserverTime, 3);
	messageClient(%client2, 'msgBountyTargetIs', "", "<none>");
}

function DuelGame::CheckDistanceDraw(%game)
{
   for (%i = 0; %i < ClientGroup.getCount(); %i++)
      ClientGroup.getObject(%i).DistanceDrawChecked = false;
      
   for (%i = 0; %i < ClientGroup.getCount(); %i++)
   {
      %cl1 = ClientGroup.getObject(%i);
      %cl2 = %cl1.clientDuelingWith;

      if ((%cl2 != 0) && !%cl1.DistanceDrawChecked)
      {
         %cl2.DistanceDrawChecked = true;
         if (GetPlayerDistance(%cl1, %cl2) > $Duel_DistanceDrawDistance)
         {
            DisIlluminateClients(%cl1, %cl2);
            %game.DrawDuel(%cl1, "Duel is a draw due to excessive distance between duel partners");
         }
      }
   }

   cancel(Game.DistanceDrawSchedule);
   Game.DistanceDrawSchedule = Game.schedule($Duel_DistanceDrawInterval, "CheckDistanceDraw");
}

function DuelGame::CheckAmmoDraw(%game)
{
   for (%i = 0; %i < ClientGroup.getCount(); %i++)
      ClientGroup.getObject(%i).AmmoDrawChecked = false;

   for (%i = 0; %i < ClientGroup.getCount(); %i++)
   {
      %cl1 = ClientGroup.getObject(%i);
      %cl2 = %cl1.clientDuelingWith;

      if ((%cl2 != 0) && !%cl1.AmmoDrawChecked)
      {
         %cl2.AmmoDrawChecked = true;
         if (PlayerOutOfAmmo(%cl1) && PlayerOutOfAmmo(%cl2))
         {
            DisIlluminateClients(%cl1, %cl2);
            %game.DrawDuel(%cl1, "Duel is a draw because both players have ran out of ammo.");
         }
      }
   }

   cancel(Game.AmmoDrawSchedule);
   Game.AmmoDrawSchedule = Game.schedule($Duel_AmmoDrawInterval, "CheckAmmoDraw");
}

function PlayerOutOfAmmo(%client)
{
   if (!IsObject(%client.player))
      return true;

	for(%i = 0; %i < $numAmmoItems - 1; %i++)
		if (%client.player.getInventory($AmmoItem[%i]) > 0)
         return false;

   return (%client.player.getInventory("SniperRifle") == 0) && (%client.player.getInventory("grenade") == 0);
}

function AllowDuelRequest(%clientChallenger, %clientDefender)
{
   %secondsLeft = ($Host::TimeLimit * 60 * 1000 + $missionStartTime - getSimTime()) / 1000;

   if (%secondsLeft < $Duel_RequestAllowTime)
   {
      if (%clientChallenger != 0)
         messageClient(%clientChallenger, 'DuelRequestNotAllowed', '\c2Duel requesting is not allowed now.  You have to wait for mission change.');
      return false;
   }

   return true;
}

function DuelGame::spawnPlayer(%game, %client, %respawn)
{
   if (%client.isAIControlled())
      onAIRespawn(%client);
   else
      DefaultGame::spawnPlayer(%game, %client, %respawn);
}

function getPlayerHeight(%player)
{
   %posFrom = getWords(%player.getTransform(), 0, 2);
   %posTo = VectorAdd(%posFrom, "0 0 -10000");
   %hit1 = getWords(containerRayCast(%posFrom, %posTo, $TypeMasks::TerrainObjectType, 0), 1, 3);
   return VectorDist(%posFrom, %hit1);
}

function DuelGame::RemoveDuelInvincibility(%game, %client)
{
   %client.DuelInvincible = false;
}

