function DuelGame::AIInit(%game)
{
   //call the default AIInit() function
   AIInit();
}

function DuelGame::onAIRespawn(%game, %client)
{
   // Give the bot any other object to control so that he cannot control the
   // player until the duel actually starts
   %client.SetControlObject(%client.clientDuelingWith.camera);

   // Compensating for the fact that onAIRespawn() did not call
   // Game.createPlayer() with the respawn flag set
   %player = %client.player;
   %player.setInvincible(true);
   %player.setInvincibleMode($InvincibleTime,0.02);
   %player.schedule($InvincibleTime * 1000, "setInvincible", false);

   //add the default task
	if (!%client.defaultTasksAdded)
	{
		%client.defaultTasksAdded = true;
	   %client.addTask(AIEngageTask);
	   %client.addTask(AITauntCorpseTask);
  	   %client.addTask(AIPatrolTask);
	}

   //set the inv flag
   %client.spawnUseInv = true;
}

function DuelGame::onAIKilled(%game, %clVictim, %clKiller, %damageType, %implement)
{
   parent::onAIKilled(%game, %clVictim, %clKiller, %damageType, %implement);
   cancel(%clVictim.respawnThread);
}

function EquipBotAfterPlayer(%clientBot, %clientPlayer)
{
   for (%i = 0; %i < 11; %i++)
      %clientBot.favorites[%i] = %clientPlayer.favorites[%i];

   %clientBot.weaponIndex = %clientPlayer.weaponIndex;
   %clientBot.packIndex = %clientPlayer.packIndex;
   %clientBot.grenadeIndex = %clientPlayer.grenadeIndex;
   %clientBot.mineIndex = %clientPlayer.mineIndex;
}
