// Starting distance between players on duel start (in meters)
$Duel_SpawnRadius = 25;

// Acceptable terrain angles for player spawn points in degrees
//(0 = perfectly horizontal terrain, 90 = vertical wall
$Duel_MinSpawnAngle = 0;
$Duel_MaxSpawnAngle = 20;

// Acceptable difference in player elevation at the start of the duel (in meters)
$Duel_MaxElevationDiff = 2;

// Time (in ms) that the duel victor is script-killed after he kills the loser
$Duel_VictorKillTime = 3000;

// Time (in ms) between the time duel victor is script-killed and the time
// he is placed in the observer mode.  This is the window of opportunity
// for the duel partners to re-request the duel.
$Duel_VictorForceObserverTime = 6000;

// Time (in ms) that players remain invincible after the countdown ends
$Duel_StartInvincibleTime = 2000;

// Time (in ms) that the duel offer lasts before expiring
$Duel_OfferExpirationTime = 10000;

// Time (in ms) that the game checks distances between all duel partners
// so that it can illuminate those partners that get far away
$Duel_IlluminationInterval = 1000;

// Distance that duel partners have to be apart before they become
// illuminated to each other.
$Duel_IlluminationDistance = 135;

// Time (in ms) that the game checks distances between all duel partners
// so that it can call a draw if the distance is great enough
$Duel_DistanceDrawInterval = 3000;

// Distance that duel partners have to be apart before the duel is called a draw
$Duel_DistanceDrawDistance = 1000;

// Time (in ms) that the game checks whether both players have run out of ammo
// so that it can call a draw if the distance is great enough
$Duel_AmmoDrawInterval = 5000;

// Minimum time (in seconds) that has to be left in the game in order to
// allow duel requests.  This makes the map changes smoother by ensuring
// that as few as possible duels are interrupted
$Duel_RequestAllowTime = 1 * 60;

// Threshold height for MA detection (in meters)
$Duel_MAThreshold = 5;

// This list defined which standard T2 missions will be used as Duel maps
$duelMissionCount = -1;
$duelMission[$duelMissionCount++] = "Abominable";
$duelMission[$duelMissionCount++] = "Alcatraz";
$duelMission[$duelMissionCount++] = "BeggarsRun";
$duelMission[$duelMissionCount++] = "Damnation";
$duelMission[$duelMissionCount++] = "DustToDust";
$duelMission[$duelMissionCount++] = "Equinox";
$duelMission[$duelMissionCount++] = "Escalade";
$duelMission[$duelMissionCount++] = "Gehenna";
$duelMission[$duelMissionCount++] = "IceBound";
$duelMission[$duelMissionCount++] = "Insalubria";
$duelMission[$duelMissionCount++] = "Invictus";
$duelMission[$duelMissionCount++] = "JacobsLadder";
$duelMission[$duelMissionCount++] = "Masada";
$duelMission[$duelMissionCount++] = "Oasis";
$duelMission[$duelMissionCount++] = "Tombstone";
$duelMission[$duelMissionCount++] = "UltimaThule";
$duelMission[$duelMissionCount++] = "Whiteout";
$duelMissionCount++;

// This list defined the items/weapons that are not allowing in Duel games
$InvBanList[Duel, "CameraGrenade"] = 1;
$InvBanList[Duel, "InventoryDeployable"] = 1;
$InvBanList[Duel, "PulseSensorDeployable"] = 1;
$InvBanList[Duel, "MotionSensorDeployable"] = 1;
$InvBanList[Duel, "TurretIndoorDeployable"] = 1;
$InvBanList[Duel, "TurretOutdoorDeployable"] = 1;
$InvBanList[Duel, "ElfBarrelPack"] = 1;
$InvBanList[Duel, "MortarBarrelPack"] = 1;
$InvBanList[Duel, "PlasmaBarrelPack"] = 1;
$InvBanList[Duel, "AABarrelPack"] = 1;
$InvBanList[Duel, "MissileBarrelPack"] = 1;
$InvBanList[Duel, "Mine"] = 1;
$InvBanList[Duel, "Beacon"] = 1;


