$spawn_minX = 0;
$spawn_miny = 0;
$spawn_maxX = 0;
$spawn_maxY = 0;
$spawn_width = 0;
$spawn_height = 0;

function abs(%val)
{
	if (%val < 0)
		return %val * -1;
	else
		return %val;
}

function InitalizeSpawn()
{
   %obj = getGroupObjectByName(MissionGroup, "MissionArea");

   $spawn_minX = getWord(%obj.area, 0) + 2 * $Duel_SpawnRadius;
   $spawn_minY = getWord(%obj.area, 1) + 2 * $Duel_SpawnRadius;
   $spawn_maxX = getWord(%obj.area, 2) - 2 * $Duel_SpawnRadius;
   $spawn_maxY = getWord(%obj.area, 3) - 2 * $Duel_SpawnRadius;
   $spawn_width = $spawn_maxX - $spawn_minX;
   $spawn_height = $spawn_maxY - $spawn_minY;
}

function getTerrainAngleAtPoint(%pos)
{
   %pos1 = VectorAdd(%pos, "0 0 1000");
   %pos2 = VectorAdd(%pos, "0 0 -1000");

   %hit1 = containerRayCast(%pos1, %pos2, $TypeMasks::TerrainObjectType, 0);
   %norm1 = getWord(%hit1, 4) @ " " @ getWord(%hit1, 5) @ " " @ getWord(%hit1, 6);
   return getTerrainAngle(%norm1);
}

function PickDuelSpawnPoints(%client1, %client2)
{
   for(%attempt1 = 0; %attempt1 < 50; %attempt1++)
   {
      for(%attempt2 = 0; %attempt2 < 200; %attempt2++)
      {
         %client1.SpawnPoint = findRandomSpawnPoint();
         %spawnAngle = getTerrainAngleAtPoint(%client1.SpawnPoint);
         if ((%spawnAngle >= $Duel_MinSpawnAngle) && (%spawnAngle <= $Duel_MaxSpawnAngle))
            break;
      }

      if (%attempt2 == 200)
         break;

      for(%attempt3 = 0; %attempt3 < 50; %attempt3++)
      {
         %client2.SpawnPoint = findNearbySpawnPoint(%client1.SpawnPoint, $Duel_SpawnRadius);
         %spawnAngle = getTerrainAngleAtPoint(%client2.SpawnPoint);
         if ((%spawnAngle >= $Duel_MinSpawnAngle) && (%spawnAngle <= $Duel_MaxSpawnAngle))
            if (abs(getWord(VectorSub(%client1.SpawnPoint, %client2.SpawnPoint), 2)) < $Duel_MaxElevationDiff)
               break;
      }

      if (%attempt3 != 50)
         break;
   }

   if ((%attempt1 == 50) || (%attempt2 == 200) || (%attempt3 == 50))
   {
      %client1.SpawnPoint = "10 0 200";
      %client2.SpawnPoint = "-10 0 200";
   }
}

function MakeClientsFaceEachOther(%client1, %client2)
{
	%loc1 = getVector(%client1.player.getTransform());
	%loc2 = getVector(%client2.player.getTransform());

	%loc1xy = setWord(%loc1, 2, 0);
	%loc2xy = setWord(%loc2, 2, 0);

   if(VectorDist(%loc1xy, %loc2xy) == 0)
      return;

   %vec12 = VectorNormalize(VectorSub(%loc1xy, %loc2xy));

	%angle = mAcos(getWord(%vec12, 1));

	if (getWord(%vec12, 0) > 0)
		{
		%rot1 = " 0 0 1 " @ (%angle + $pi);
		%rot2 = " 0 0 1 " @ (%angle );
		}
	else
		{
		%rot1 = " 0 0 1 " @ ($pi - %angle);
		%rot2 = " 0 0 1 " @ (($pi - %angle) + $pi);
		}

	%client1.player.setTransform(%loc1 @ " " @ %rot1);
	%client2.player.setTransform(%loc2 @ " " @ %rot2);
}

function findRandomSpawnPoint()
{
   %mask = $TypeMasks::VehicleObjectType     | $TypeMasks::MoveableObjectType   |
           $TypeMasks::StaticShapeObjectType | $TypeMasks::StaticTSObjectType   |
           $TypeMasks::ForceFieldObjectType  | $TypeMasks::ItemObjectType       |
           $TypeMasks::PlayerObjectType      | $TypeMasks::TurretObjectType     |
           $TypeMasks::InteriorObjectType    | $TypeMasks::WaterObjectType;

	for (%attempts = 0; %attempts < 20; %attempts++)
	{
		%x = getRandom($spawn_width) + $spawn_minX;
		%y = getRandom($spawn_height) + $spawn_minY;
		%z = getTerrainHeight(%x @ " " @ %y);
		%loc = %x @ " " @ %y @ " " @ %z;

		InitContainerRadiusSearch(%loc, 20, %mask);

      if (ContainerSearchNext() == 0)
			{
			InitContainerRadiusSearch(%loc, 20, $TypeMasks::PlayerObjectType);

			if (ContainerSearchNext() == 0)
				return %loc;
			}
	}

	return "0 0 0";
}

function findNearbySpawnPoint(%loc, %distance)
{
	%mask = $TypeMasks::VehicleObjectType     | $TypeMasks::MoveableObjectType   |
           $TypeMasks::StaticShapeObjectType | $TypeMasks::StaticTSObjectType   |
           $TypeMasks::ForceFieldObjectType  | $TypeMasks::ItemObjectType       |
           $TypeMasks::PlayerObjectType      | $TypeMasks::TurretObjectType     |
           $TypeMasks::InteriorObjectType    | $TypeMasks::WaterObjectType;

	for (%attempts = 0; %attempts < 20; %attempts++)
	{
		%angle = $pi * getRandom(360) / 180;
		%x = getWord(%loc, 0) + %distance * mCos(%angle);
		%y = getWord(%loc, 1) + %distance * mSin(%angle);
		%z = getTerrainHeight(%x @ " " @ %y);
		%newLoc = %x @ " " @ %y @ " " @ %z;

		InitContainerRadiusSearch(%newLoc, 2, %mask);

      if (ContainerSearchNext() == 0)
         if (checkLocLOS(%loc, %newLoc) == 1)
   			return %newLoc;
	}

	return "0 0 0";
}

function checkClientLOS(%client1, %client2)
{
   %loc1 = %client1.player.getTransform();
   %loc2 = %client2.player.getTransform();

   return checkLocLOS(%loc1, %loc2);
}

function checkLocLOS(%loc1, %loc2)
{
   %loc1 = VectorAdd(%loc1, "0 0 1");
   %loc2 = VectorAdd(%loc2, "0 0 1");
   
   %hit1 = containerRayCast(%loc1, %loc2, $TypeMasks::TerrainObjectType, 0);
   return %hit1 == 0;
}

